<?php

/**===================================
 * Protecteddownload
 * ===================================
 * Enabeling the download of a .htaccess protected file
 * from folder: downloads/protected/
 * @copyright 2013-2014 by svasti@svasti.de
 * @version 1.5
 * @link http://frankziesing.de/cmsimple/?Start:Protected_Download
 *
 * Use {{{protecteddownload('full filename');}}}
 * files are supposed to be in folder downloads/protected/
 *
 * History:
 * 1.1 errormessage added, code by cmb
 * 1.2 small change in download package
 * 1.3 filenames can contain spaces (e.g. MS-Word filenames)
 * 1.4 added .htaccess to download
 * 1.5 All chars and Windows-1252 encoding in filenames enabled
 */

function protecteddownload($file)
{
    global $pth;
    $o = '';

$fileencoding = "Windows-1252";
$file1 = $file;

    if (!is_readable($pth['folder']['downloads'].'protected/'.$file)) {
        $file = mb_convert_encoding($file, $fileencoding, "UTF-8");
        if (!is_readable($pth['folder']['downloads'].'protected/'.$file)) {
            e('notreadable', 'file', $pth['folder']['downloads'].'protected/'.$file);
            return;
        } 
    } 

    $basename = strpos($file1,'/')
        ? substr($file1,(strpos($file1,'/')+1))
        : $file1;
    $basename = rawurlencode($basename);
    $basename = str_replace(array(' ','-','~','_','%','.'),'',$basename);
    $dirname  = dirname($file1);
    $filename = $dirname != '.'
        ? $dirname . '/' . $basename
        : $basename;

    if(isset($_POST['protecteddownload'.$filename]))
    {
        header('Content-Description: File Transfer');
        header('Content-Type: application/octet-stream');
        header('Content-Disposition: attachment; filename="'.$file.'"');
        header('Content-Transfer-Encoding: binary');
        header('Content-Length: ' . filesize($pth['folder']['downloads'].'protected/'.$file));
        ob_clean();
        readfile($pth['folder']['downloads'].'protected/'.$file);
        exit();
    }

    $o .= '<form action="" style="text-align:center;" method="post">'
       .  '<p>'
       .  tag('input type="submit"
          style="cursor:pointer;font-weight:bold;letter-spacing:.2em;padding:.2em 1em;border-radius:1em;"
          value="Download &nbsp;'
       .  $file1.'" name="protecteddownload'.$filename.'"')
       . '</p></form>'
       . "\n";

    return $o;
}